licky = LibStub("AceAddon-3.0"):NewAddon("alasin_Counter", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0")

local ldefaults = {
  char = {
    licks = 0,
    jumps = 0,
    nods = 0,
    cheers = 0,
    dances = 0,
  },
}

function licky:calcLickyScore()
  local d = self.adb
  local goods = d.licks + d.nods + d.cheers + d.dances
  local bads = d.jumps
  score = (goods * 10 - ( bads / 10 ))
  return score
end

function licky:IncrementEmote(event, ...)
  if select(2, ...) == UnitName("player") then
    local str = select(1, ...)
    if strfind(str, "You lick") then self.adb.licks = self.adb.licks + 1 end
    if strfind(str, "You nod") then self.adb.nods = self.adb.nods + 1 end
    if strfind(str, "You cheer") then self.adb.cheers = self.adb.cheers + 1 end
    if strfind(str, "You dance with") then self.adb.dances = self.adb.dances + 1 end
    if strfind(str, "You burst into dance") then self.adb.dances = self.adb.dances + 1 end
  end
end

function licky:OnInitialize()
  self:RegisterEvent("CHAT_MSG_EMOTE", "IncrementEmote")
  self:RegisterEvent("CHAT_MSG_TEXT_EMOTE", "IncrementEmote")
  self:SecureHook("JumpOrAscendStart")

  self.db = LibStub("AceDB-3.0"):New("counterDB", ldefaults)
  self.adb = self.db.char

  self:RegisterChatCommand("licky", "ChatCommand")
  self:RegisterChatCommand("lscore", "LickyScore")
  self:RegisterChatCommand("lickyscore", "LickyScore")
  self:RegisterChatCommand("jumpy", "ChatCommand")
  self:RegisterChatCommand("dancy", "ChatCommand")
end

function licky:JumpOrAscendStart()
  if UnitOnTaxi("player") or IsFlying() or IsSwimming() or HasFullControl() == false or UnitIsDead("player") then return end
  self.adb.jumps = self.adb.jumps + 1
end

function licky:LickyScore()
  StaticPopupDialogs["LS"] = {
    text = format([[|cFFFF7F24licky score|r
    
    Your current licky score is %s.

    |cFFFF7F24licky score|r was brought to you by the fine folks at Alasin <Nesingwary> who really think that the true measure of a pro is their licky score (not really).

    Alasin is at http://thealasin.com if you're looking for the greatest guild on earth.
    ]], self:calcLickyScore()),
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  button1 = "/lick",
  }
  StaticPopup_Show ("LS")
end

function licky:ChatCommand(str)
  local switch, message = str:match("^(%S*)%s*(.-)$");
  local cmd = string.lower(switch)
  local msg = string.lower(message)

  if cmd == "reset" then
    self.adb = {
      licks = 0,
      jumps = 0,
      nods = 0,
      cheers = 0,
      dances = 0,     
    }
  else
    self:Print("Here's your stats:")
    self:Print("|cFFFF0000Type /lscore for your Licky Score!|r")    
    self:Print("|cFFFF7F24Jumps|r: ".. self.adb.jumps)
    self:Print("|cFFFF7F24Licks|r: ".. self.adb.licks)
    self:Print("|cFFFF7F24Dances|r: ".. self.adb.dances)
    self:Print("|cFFFF7F24Cheers|r: ".. self.adb.cheers)    
    self:Print("|cFFFF7F24Nods:|r ".. self.adb.nods)    
  end
end